/* RSA Encryption and Decryption */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

/*global variables*/

unsigned long keyE=13;		/*public key*/
unsigned long keyM=323;		/*modulo*/
unsigned long keyD=133;		/*secret key*/
char E[32],M[32],D[32];		/*their binaly values*/


/*functions*/

char encrypt(void);									/*file encrypting rootine*/
char decrypt(void);									/*file decrypting rootine*/
unsigned long p2c(char);							/*charactor encrypting kernel*/
char c2p(unsigned long);							/*code decrypting kernel*/
void setE(void);									/*let user input public key e*/
void setM(void);									/*let user input modulo m*/
void setD(void);									/*let user input secret key d*/
void bin(unsigned long,char *);						/*translate decimal value to octal value*/
unsigned long ulpow(unsigned long,unsigned long);	/*power*/
unsigned long modulo(unsigned long,unsigned long);	/*modulo*/
unsigned long modpow(unsigned long,unsigned long);	/*power with modulo*/


void main() {
	char line[10];	/*input line*/
	char ed;		/*encrypt or decrypt*/
	char flag;		/*error check flag*/

	printf("\n=========================================\n");
	printf("      RSA Enctyption and Decryption\n");
	printf("=========================================\n\n");
	
	do {
		printf("\n'e' encrypt / 'd' decrypt _");
		fgets(line,sizeof(line),stdin);
		sscanf(line,"%c",&ed);
		switch(ed) {
			case 'e':
				flag=encrypt();
				break;
			case 'd':
				flag=decrypt();
				break;
			default:
				flag = -1;
		}
		if (flag!=0) {
			printf("\nGood night. =D\n");
		} else {
			printf("\nFile succesfully transformed. :D\n");
		}
	} while(flag==0);
}

char encrypt() {
	char p;				/*one charactor in the plain text*/
	unsigned long c;	/*one cypher code translated from p*/
	char counter;		/*encrypted charactors*/

	char p_name[128];	/*the name of plain text file*/
	char c_name[128];	/*the name of cypher text file*/
	FILE *p_file;		/*plain text file for input*/
	FILE *c_file;		/*cypher code file for output*/

	/*set keys*/
	setE();
	setM();

	/*set plain text filename*/
	printf("\nInput PLAIN text filename for input.\n");
	printf("[plain.txt] _");
	fgets(p_name,sizeof(p_name),stdin);
	if (strlen(p_name)==1) {		/*default*/
		strcpy(p_name,"plain.txt");
	} else {
		p_name[strlen(p_name)-1] = '\0';
	}

	/*opening plain text file*/
	p_file = fopen(p_name,"r");
	if (p_file == NULL) {			/*check the file error*/
		printf("Cannot open [%s] for input.\n",p_name);
		return(1);
	}
	printf("[%s] was succesfully opened.\n",p_name);

	/*set cypher codes file name*/
	printf("\nInput CYPHER codes filename for output.\n");
	printf("[cypher.txt] _");
	fgets(c_name,sizeof(c_name),stdin);
	if (strlen(c_name)==1) {		/*default*/
		strcpy(c_name,"cypher.txt");
	} else {
		c_name[strlen(c_name)-1] = '\0';
	}

	/*opening cypher codes file*/
	c_file = fopen(c_name,"w");
	if (c_file == NULL) {			/*check the file error*/
		printf("Cannot open [%s] for output.\n",c_name);
		return(1);
	}
	printf("[%s] was succesfully opened.\n",c_name);

	/*translation*/
	printf("\n[Encrypted Plain Text]\n");
	counter=0;
	while(1) {
		p=fgetc(p_file);
		if (p==EOF) break;
		c=p2c(p);
		printf("%ld ",c);
		fprintf(c_file,"%ld ",c);
		if (++counter==16) {
			counter=0;
			printf("\n");
			fprintf(c_file,"\n");
		}
	}
	printf("[EOF]\n");

	/*closing files*/
	fclose(p_file);
	fclose(c_file);

	return(0);
}

char decrypt() {
	unsigned long c;	/*one cypher code in the cypher codes*/
	char p;				/*one plain charactor translated from c*/
	char flag,counter;	/*decrypted codes*/

	char c_name[128];	/*the name of cypher text file*/
	char p_name[128];	/*the name of plain text file*/
	FILE *c_file;		/*cypher codes file for input*/
	FILE *p_file;		/*plain text file for output*/

	/*set keys*/
	setD();
	setM();

	/*set cypher codes filename*/
	printf("\nInput CYPHER codes filename for input.\n");
	printf("[cypher.txt] _");
	fgets(c_name,sizeof(c_name),stdin);
	if (strlen(c_name)==1) {		/*default*/
		strcpy(c_name,"cypher.txt");
	} else {
		c_name[strlen(c_name)-1] = '\0';
	}

	/*opening cypher codes file*/
	c_file = fopen(c_name,"r");
	if (c_file == NULL) {			/*check the file error*/
		printf("Cannot open [%s] for input.\n",c_name);
		return(1);
	}
	printf("[%s] was succesfully opened.\n",c_name);

	/*set plain text filename*/
	printf("\nInput PLAIN text filename for output.\n");
	printf("[decrypt.txt] _");
	fgets(p_name,sizeof(p_name),stdin);
	if (strlen(p_name)==1) {		/*default*/
		strcpy(p_name,"decrypt.txt");
	} else {
		p_name[strlen(p_name)-1] = '\0';
	}

	/*opening plain text file*/
	p_file = fopen(p_name,"w");
	if (p_file == NULL) { /*check the file error*/
		printf("Cannot open [%s] for output.\n",p_name);
		return(1);
	}
	printf("[%s] was succesfully opened.\n",p_name);

	/*translation*/
	printf("\n[Decrypted Plain Text]\n");
	counter=0;
	while(1) {
		flag=fscanf(c_file,"%d ",&c);
		if (flag!=1) break;
		if (++counter==16) {
			counter=0;
			fscanf(c_file,"\n");
		}
		if (flag!=1) break;
		p=c2p(c);
		printf("%c",p);
		fprintf(p_file,"%c",p);
	}
	printf("[EOF]\n");
	fclose(c_file);

	/*closing files*/
	fclose(p_file);

	return(0);
}

unsigned long p2c(char p) {
	unsigned long c=1;		/*cypher code*/
	unsigned long temp=p;	/*fat baloon*/
	int b;					/*one bit*/

	for (b=31 ; b>=0 ;b--) {
		if (E[b]==1) {
			c *= temp;
			c = modulo(c,keyM);
		}
		temp=modpow(temp,2);
	}
	return(c);
}

char c2p(unsigned long c) {
	unsigned long p=1;	/*plain charactor*/
	int b;				/*one bit*/

	for (b=31 ; b>=0 ;b--) {
		if (D[b]==1) {
			p *= modpow(c,ulpow(2,31-b));
			p = modulo(p,keyM);
		}
	}
	return((char)p);
}

void setE(void) {
	char line[100];

	printf("Public key E [%ld] =",keyE);
	fgets(line,sizeof(line),stdin);
	if (strlen(line)==1) {
		keyE=keyE;			/*default*/
	} else {
		sscanf(line,"%ld",&keyE);
	}
	bin(keyE,&E[0]);
}

void setM(void) {
	char line[100];

	printf("Modulo M [%ld] =",keyM);
	fgets(line,sizeof(line),stdin);
	if (strlen(line)==1) {
		keyM=keyM;		/*default*/
	} else {
		sscanf(line,"%ld",&keyM);
	}
}

void setD(void) {
	char line[100];

	printf("Secret key D [%ld] =",keyD);
	fgets(line,sizeof(line),stdin);
	if (strlen(line)==1) {
		keyD=keyD;			/*default*/
	} else {
		sscanf(line,"%ld",&keyD);
	}
	bin(keyD,&D[0]);
}

void bin(unsigned long v,char *B) {
	unsigned long mask;	/*a value when only one bit is standing*/
	int b;				/*one bit*/

	for (b=31 ; b>=0 ; b--) {
		mask=ulpow(2,b);
		if (v>=mask) {
			*(B+31-b)=1;
			v -= mask;
		} else {
			*(B+31-b)=0;
		}
		printf("%d",*(B+31-b));
	}
	printf("\n");
}

unsigned long ulpow(unsigned long x,unsigned long y) {
	unsigned long c,pow=1;

	if (y==0) return(1);
	for (c=1 ; c<=y ; c++) {
		pow*=x;
	}
	return(pow);
}

unsigned long modulo(unsigned long x,unsigned long y) {
	unsigned long ans;
	long i=x/y;

	ans=x-i*y;
	return (ans);
}

unsigned long modpow(unsigned long x,unsigned long y) {
	unsigned long ans=1,c;

	if (y==0) return(1);
	for (c=1 ; c<=y ; c++) {
		ans *= x;
		ans = modulo(ans,keyM);
	}
	return (ans);
}

